Index: sansmodels/src/sans/models/media/model_functions.html
===================================================================
--- sansmodels/src/sans/models/media/model_functions.html	(revision b71a53b341c545d3723f00a89fb361a67d61cce3)
+++ sansmodels/src/sans/models/media/model_functions.html	(revision 657e52c6e801e630d2fc6f1722a752b701d20771)
@@ -8,5 +8,5 @@
 <li style="line-height: 115%;"><a href="#Introduction"><strong>Introduction</strong></a></li>
 <li style="line-height: 115%;"><a href="#Shapes"><strong>Shapes</strong></a>: <a href="#SphereModel">SphereModel</a>, <a href="#BinaryHSModel">BinaryHSModel</a>, <a href="#FuzzySphereModel">FuzzySphereModel</a>, <a href="#RaspBerryModel">RaspBerryModel</a>, <a href="#CoreShellModel">CoreShellModel</a>,&nbsp;<a href="#Core2ndMomentModel">Core2ndMomentModel</a>, <a href="#CoreMultiShellModel">CoreMultiShellModel</a>, <a href="#VesicleModel">VesicleModel</a>, <a href="#MultiShellModel">MultiShellModel</a>, &nbsp;<a href="#OnionExpShellModel">OnionExpShellModel</a>, <a href="#SphericalSLDModel">SphericalSLDModel</a>, <a href="#LinearPearlsModel">LinearPearlsModel</a>, <a href="#PearlNecklaceModel">PearlNecklaceModel</a> , <a href="#CylinderModel">CylinderModel</a>, <a href="#CoreShellCylinderModel">CoreShellCylinderModel</a>, <a href="#CoreShellBicelleModel">CoreShellBicelleModel</a>,<a href="#HollowCylinderModel">HollowCylinderModel</a>, <a href="#FlexibleCylinderModel">FlexibleCylinderModel</a>, <a href="#FlexibleCylinderModel">FlexCylEllipXModel</a>, <a href="#StackedDisksModel">StackedDisksModel</a>, <a href="#ParallelepipedModel">ParallelepipedModel</a>, <a href="#CSParallelepipedModel">CSParallelepipedModel</a>, <a href="#EllipticalCylinderModel">EllipticalCylinderModel</a>, <a href="#BarBellModel">BarBellModel</a>, <a href="#CappedCylinderModel">CappedCylinderModel</a>, <a href="#EllipsoidModel">EllipsoidModel</a>, <a href="#CoreShellEllipsoidModel">CoreShellEllipsoidModel</a>, <a href="#TriaxialEllipsoidModel">TriaxialEllipsoidModel</a>, <a href="#LamellarModel">LamellarModel</a>, <a href="#LamellarFFHGModel">LamellarFFHGModel</a>, <a href="#LamellarPSModel">LamellarPSModel</a>, <a href="#LamellarPSHGModel">LamellarPSHGModel</a>, <a href="#LamellarPCrystalModel">LamellarPCrystalModel</a>, <a href="#SCCrystalModel">SCCrystalModel</a>, <a href="#FCCrystalModel">FCCrystalModel</a>, <a href="#BCCrystalModel">BCCrystalModel</a>.</li>
-<li style="line-height: 115%;"><a href="#Shape-Independent"><strong>Shape-Independent</strong></a>: <a href="#Absolute%20Power_Law">AbsolutePower_Law</a>, <a href="#BEPolyelectrolyte">BEPolyelectrolyte</a>, <a href="#BroadPeakModel">BroadPeakModel,<span><span style="text-decoration: underline;"><span style="color: blue;">CorrLength</span></span></span><span>,</span></a> <a href="#DAB_Model">DAB_Model</a>, <a href="#Debye">Debye</a>, <a href="#Number_Density_Fractal">FractalModel</a>, <a href="#FractalCoreShell">FractalCoreShell</a>, <a href="#GaussLorentzGel">GaussLorentzGel</a>, <a href="#Guinier">Guinier</a>, <a href="#GuinierPorod">GuinierPorod</a>, <a href="#Lorentz">Lorentz</a>, <a href="#Mass_Fractal">MassFractalModel</a>, <a href="#MassSurface_Fractal">MassSurfaceFractal</a>, <a href="#Peak%20Gauss%20Model">PeakGaussModel</a>, <a href="#Peak%20Lorentz%20Model">PeakLorentzModel</a>, <a href="#Poly_GaussCoil">Poly_GaussCoil</a>, <a href="#PolymerExclVolume">PolyExclVolume</a>, <a href="#PorodModel">PorodModel</a>, <a href="#RPA10Model">RPA10Model</a>, <a href="#StarPolymer">StarPolymer</a>, <a href="#Surface_Fractal">SurfaceFractalModel</a>, <a href="#Teubner%20Strey">Teubner Strey</a>, <a href="#TwoLorentzian">TwoLorentzian</a>, <a href="#TwoPowerLaw">TwoPowerLaw</a>, <a href="#UnifiedPowerRg">UnifiedPowerRg</a>, <a href="#LineModel">LineModel</a>, <a href="#ReflectivityModel">ReflectivityModel</a>, <a href="#ReflectivityIIModel">ReflectivityIIModel</a>, <a href="#GelFitModel">GelFitModel</a>.</li>
+<li style="line-height: 115%;"><a href="#Shape-Independent"><strong>Shape-Independent</strong></a>: <a href="#Absolute%20Power_Law">AbsolutePower_Law</a>, <a href="#BEPolyelectrolyte">BEPolyelectrolyte</a>, <a href="#BroadPeakModel">BroadPeakModel,<span><span style="text-decoration: underline;"><span style="color: blue;">CorrLength</span></span></span><span>,</span></a> <a href="#DABModel">DAB_Model</a>, <a href="#Debye">Debye</a>, <a href="#Number_Density_Fractal">FractalModel</a>, <a href="#FractalCoreShell">FractalCoreShell</a>, <a href="#GaussLorentzGel">GaussLorentzGel</a>, <a href="#Guinier">Guinier</a>, <a href="#GuinierPorod">GuinierPorod</a>, <a href="#Lorentz">Lorentz</a>, <a href="#Mass_Fractal">MassFractalModel</a>, <a href="#MassSurface_Fractal">MassSurfaceFractal</a>, <a href="#Peak%20Gauss%20Model">PeakGaussModel</a>, <a href="#Peak%20Lorentz%20Model">PeakLorentzModel</a>, <a href="#Poly_GaussCoil">Poly_GaussCoil</a>, <a href="#PolymerExclVolume">PolyExclVolume</a>, <a href="#PorodModel">PorodModel</a>, <a href="#RPA10Model">RPA10Model</a>, <a href="#StarPolymer">StarPolymer</a>, <a href="#Surface_Fractal">SurfaceFractalModel</a>, <a href="#TeubnerStreyModel">Teubner Strey</a>, <a href="#TwoLorentzian">TwoLorentzian</a>, <a href="#TwoPowerLaw">TwoPowerLaw</a>, <a href="#UnifiedPowerRg">UnifiedPowerRg</a>, <a href="#LineModel">LineModel</a>, <a href="#ReflectivityModel">ReflectivityModel</a>, <a href="#ReflectivityIIModel">ReflectivityIIModel</a>, <a href="#GelFitModel">GelFitModel</a>.</li>
 <li style="line-height: 115%;"><a href="#Model"><strong>Customized Models</strong></a>: <a href="#testmodel">testmodel</a>, <a href="#testmodel_2">testmodel_2</a>, <a href="#sum_p1_p2">sum_p1_p2</a>, <a href="#sum_Ap1_1_Ap2">sum_Ap1_1_Ap2</a>, <a href="#polynomial5">polynomial5</a>, <a href="#sph_bessel_jn">sph_bessel_jn</a>.</li>
 <li style="line-height: 115%;"><a href="#Structure_Factors"><strong>Structure Factors</strong></a>: <a href="#HardsphereStructure">HardSphereStructure</a>, <a href="#SquareWellStructure">SquareWellStructure</a>, <a href="#HayterMSAStructure">HayterMSAStructure</a>, <a href="#StickyHSStructure">StickyHSStructure</a>.</li>
@@ -242,4 +242,5 @@
 <p>where the amplitude A(q) is given as the typical sphere scattering convoluted with a Gaussian to get a gradual drop-off in the scattering length density:</p>
 <p style="text-align: center;" align="center"><span style="position: relative; top: 18pt;"><img src="img/image011.PNG" alt="" /></span></p>
+<br>
 <p>Here A2(q) is the form factor, P(q). The &lsquo;scale&rsquo; is equivalent to the volume fraction of spheres, each of volume, V. Contrast (<em><span style="font-family: 'Arial','sans-serif';">&Delta;</span>&rho;</em> ) is the difference of scattering length densities of the sphere and the surrounding solvent.</p>
 <p>The poly-dispersion in radius and in fuzziness is provided.</p>
@@ -4937,5 +4938,5 @@
 <p style="text-align: center;" align="center"><strong><span style="font-size: 14pt;"><img id="Picture 75" src="img/image179.jpg" alt="" /></span></strong></p>
 <p style="text-align: center;" align="center"><strong><span style="font-size: 14pt;">&nbsp;</span>Figure. 1D plot using the default values (w/200 data point).</strong></p>
-<p style="margin-left: 0.55in; text-indent: -0.3in;"><strong><span style="font-size: 14pt;">3.5.</span></strong><strong><span style="font-size: 7pt;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></strong><strong><span style="font-size: 14pt;">&nbsp;<a name="DAB_Model"></a>DAB (Debye-Anderson-Brumberger)_Model</span></strong></p>
+<p style="margin-left: 0.55in; text-indent: -0.3in;"><strong><span style="font-size: 14pt;">3.5.</span></strong><strong><span style="font-size: 7pt;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></strong><strong><span style="font-size: 14pt;">&nbsp;<a name="DABModel"></a>DAB (Debye-Anderson-Brumberger)_Model</span></strong></p>
 <p style="margin-left: 0.55in;"><strong><span style="font-size: 14pt;">&nbsp;</span></strong></p>
 <p style="margin-left: 0.25in;">Calculates the scattering from a randomly distributed, two-phase system based on the Debye-Anderson-Brumberger (DAB) model for such systems. The two-phase system is characterized by a single length scale, the correlation length, which is a measure of the average spacing between regions of phase 1 and phase 2. The model also assumes smooth interfaces between the phases and hence exhibits Porod behavior (I ~ Q-4) at large Q (Q*correlation length &gt;&gt; 1).</p>
@@ -5060,5 +5061,5 @@
 <p style="text-align: center;" align="center"><img id="Picture 77" src="img/image183.jpg" alt="" /></p>
 <p style="text-align: center;" align="center"><strong>Figure. 1D plot using the default values (w/200 data point).</strong></p>
-<p style="margin-left: 0.55in; text-indent: -0.3in;"><strong><span style="font-size: 14pt;">3.7.</span></strong><strong><span style="font-size: 7pt;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></strong><strong><span style="font-size: 14pt;">&nbsp;<a name="Teubner Strey"></a>Teubner Strey (Model)</span></strong></p>
+<p style="margin-left: 0.55in; text-indent: -0.3in;"><strong><span style="font-size: 14pt;">3.7.</span></strong><strong><span style="font-size: 7pt;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </span></strong><strong><span style="font-size: 14pt;">&nbsp;<a name="TeubnerStreyModel"></a>Teubner Strey (Model)</span></strong></p>
 <p style="margin-left: 0.25in;">This function calculates the scattered intensity of a two-component system using the Teubner-Strey model.</p>
 <p style="margin-left: 0.25in;"><strong><span style="font-size: 14pt;">&nbsp;</span></strong></p>